package me.unurled.sacredrealms.sr.components.player;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonParseException;
import java.lang.reflect.Type;
import me.unurled.sacredrealms.sr.components.item.ItemStackDeserializer;
import org.bukkit.Bukkit;
import org.bukkit.event.inventory.InventoryType;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.jetbrains.annotations.NotNull;

public class InventoryDeserializer implements JsonDeserializer<Inventory> {

  @Override
  public Inventory deserialize(
      @NotNull JsonElement jsonElement,
      Type type,
      JsonDeserializationContext jsonDeserializationContext)
      throws JsonParseException {
    Inventory inv = Bukkit.createInventory(null, InventoryType.PLAYER);
    // parse from a string, to a list of string
    String[] contents = jsonElement.getAsString().split(";");
    // iterate through the list of strings and create ItemStacks with deserialize()
    Gson gson =
        new GsonBuilder()
            .registerTypeAdapter(ItemStack.class, new ItemStackDeserializer())
            .create();
    for (int i = 0; i < contents.length; i++) {
      if (contents[i].equals("null")) {
        inv.setItem(i, null);
      } else {
        ItemStack item = gson.fromJson(contents[i], ItemStack.class);
        if (item != null) inv.setItem(i, item);
      }
    }
    return inv;
  }
}
