package me.unurled.sacredrealms.sr.components.player;

import com.google.gson.JsonElement;
import com.google.gson.JsonPrimitive;
import com.google.gson.JsonSerializationContext;
import com.google.gson.JsonSerializer;
import java.lang.reflect.Type;
import java.util.Arrays;
import java.util.List;
import org.bukkit.inventory.Inventory;
import org.jetbrains.annotations.NotNull;

public class InventorySerializer implements JsonSerializer<Inventory> {

  @Override
  public JsonElement serialize(
      @NotNull Inventory itemStacks, Type type, JsonSerializationContext jsonSerializationContext) {
    List<String> collect =
        Arrays.stream(itemStacks.getContents())
            .map(item -> item == null ? "null" : Arrays.toString(item.serializeAsBytes()))
            .toList();

    String s = String.join(";", collect);
    return new JsonPrimitive(s);
  }
}
