package me.unurled.sacredrealms.sr.components.player;

import static me.unurled.sacredrealms.sr.utils.Logger.error;

import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonParseException;
import java.lang.reflect.Type;
import org.bukkit.NamespacedKey;
import org.bukkit.Registry;
import org.bukkit.potion.PotionEffect;
import org.bukkit.potion.PotionEffectType;

public class PotionEffectDeserializer implements JsonDeserializer<PotionEffect> {

  @Override
  public PotionEffect deserialize(
      JsonElement jsonElement, Type type, JsonDeserializationContext jsonDeserializationContext)
      throws JsonParseException {
    try {
      String pot = jsonElement.getAsString();
      pot = pot.replace("{", "").replace("}", "");
      String[] parts = pot.split(",");
      // find the potion effect type from the string part[0] is a key
      PotionEffectType pet =
          Registry.POTION_EFFECT_TYPE.get(new NamespacedKey("minecraft", parts[0]));
      int duration = Integer.parseInt(parts[1]);
      int amplifier = Integer.parseInt(parts[2]);
      boolean particles = Boolean.parseBoolean(parts[3]);

      return new PotionEffect(pet, duration, amplifier, false, particles, false);
    } catch (Exception e) {
      error("Error deserializing potion effect: " + e.getMessage());
    }
    return null;
  }
}
