package me.unurled.sacredrealms.sr.components.treasure;

import static me.unurled.sacredrealms.sr.utils.Component.textComp;

import java.util.HashMap;
import java.util.Map;
import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.event.inventory.InventoryType;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;

public class Treasure {

  private int id;

  /** Chest location */
  private Location location;

  /** key = place in chest value = itemstack placed in chest at key place */
  private Map<Integer, ItemStack> items;

  /** Permission to access this chest */
  private String permission;

  public Treasure(int id, Location location) {
    this.id = id;
    this.location = location;
    this.items = new HashMap<>();
    this.permission = "";
  }

  public Treasure(int id, Location location, String permission) {
    this.id = id;
    this.location = location;
    this.items = new HashMap<>();
    this.permission = permission;
  }

  public Treasure(int id, Location location, Map<Integer, ItemStack> items, String permission) {
    this.id = id;
    this.location = location;
    this.items = items;
    this.permission = permission;
  }

  /**
   * Get the id of the treasure
   *
   * @return the id of the treasure
   */
  public int getId() {
    return id;
  }

  public void setId(int id) {
    this.id = id;
  }

  /**
   * Get the location of the treasure
   *
   * @return the location of the treasure
   */
  public Location getLocation() {
    return location;
  }

  public void setLocation(Location location) {
    this.location = location;
  }

  /**
   * Get the items in the chest
   *
   * @return the items
   */
  public Map<Integer, ItemStack> getItems() {
    return items;
  }

  public void setItems(Map<Integer, ItemStack> items) {
    this.items = items;
  }

  /**
   * Get the permission to open the chest
   *
   * @return the permission
   */
  public String getPermission() {
    return permission;
  }

  public void setPermission(String permission) {
    this.permission = permission;
  }

  public Inventory getInventory() {
    Inventory inv = Bukkit.createInventory(null, InventoryType.CHEST, textComp("Treasure"));
    for (Map.Entry<Integer, ItemStack> entry : items.entrySet()) {
      inv.setItem(entry.getKey(), entry.getValue());
    }
    return inv;
  }
}
