package me.unurled.sacredrealms.sr.events.player;

import static me.unurled.sacredrealms.sr.utils.Component.comp;

import me.unurled.sacredrealms.sr.components.player.SRPlayer;
import net.kyori.adventure.text.Component;
import org.bukkit.event.Event;
import org.bukkit.event.HandlerList;
import org.jetbrains.annotations.NotNull;

public class PlayerLevelUpEvent extends Event {

  private static final HandlerList HANDLER_LIST = new HandlerList();
  private final SRPlayer p;
  private final int previousLevel;
  private Component message;

  public PlayerLevelUpEvent(SRPlayer p, int previousLevel) {
    super(true);
    this.p = p;
    this.previousLevel = previousLevel;
    /*
     * <blue>--------------------------------------------------
     *
     * <rainbow>You have leveled up from 1 to 2!
     *
     * <blue>--------------------------------------------------
     */
    message =
        comp(
            "<blue>--------------------------------------------------<br>"
                + "<br><rainbow>You have leveled up from "
                + previousLevel
                + " to "
                + p.getLevel()
                + "!<br>"
                + "<br><blue>--------------------------------------------------");
  }

  public static HandlerList getHandlerList() {
    return HANDLER_LIST;
  }

  @Override
  public @NotNull HandlerList getHandlers() {
    return HANDLER_LIST;
  }

  public SRPlayer getPlayer() {
    return p;
  }

  public int getPreviousLevel() {
    return previousLevel;
  }

  public Component getMessage() {
    return message;
  }

  public void setMessage(Component message) {
    this.message = message;
  }
}
